#1777 closed defect (fixed)

Accessing _Thread_Dispatch_disable_level should be consolidated

Reported by: Jennifer Averett Owned by: Joel Sherrill
Priority: normal Milestone: 4.11
Component: score Version: 4.11
Severity: normal Keywords:
Cc: sebastian.huber@…, gedare@… Blocked By:
Blocking:

Description

In order to support future SMP work _Thread_Dispatch_disable_level should only be touched by a handful of routines. The attached patch adds the inline routines:

_Thread_Dispatch_in_critical_section(),
_Thread_Dispatch_get_disable_level(),
_Thread_Dispatch_set_disable_level(),
_Thread_Dispatch_increment_disable_level() and
_Thread_Dispatch_decrement_disable_level().

Where possible the source has been modified to call one of these routines instead of directly accessing _Thread_Dispatch_disable_level.

Additionally, _Thread_Disable_dispatch and _Thread_Enable_dispatch were made inline only when not SMP or the heavy debug was turned on. Otherwise, the routines defined in the new files threaddisabledispatch.c and threadenabledispatch.c are used.

Attachments (2)

DispatchPatch.diff (25.3 KB) - added by Jennifer Averett on Apr 13, 2011 at 4:42:12 PM.
consolidate access to _Thread_Dispatch_disable_level
DispatchPatch_v1.diff (25.8 KB) - added by Jennifer Averett on Apr 15, 2011 at 1:26:25 PM.
consolidate access to _Thread_Dispatch_disable_level

Download all attachments as: .zip

Change History (7)

Changed on Apr 13, 2011 at 4:42:12 PM by Jennifer Averett

Attachment: DispatchPatch.diff added

consolidate access to _Thread_Dispatch_disable_level

comment:1 Changed on Apr 14, 2011 at 6:25:26 PM by Gedare Bloom

Cc: giddyup44@… added

comment:2 Changed on Apr 15, 2011 at 5:29:05 AM by Sebastian Huber

Cc: Sebastian Huber added

Changed on Apr 15, 2011 at 1:26:25 PM by Jennifer Averett

Attachment: DispatchPatch_v1.diff added

consolidate access to _Thread_Dispatch_disable_level

comment:3 Changed on Apr 15, 2011 at 1:26:25 PM by Jennifer Averett

attachments.isobsolete: 01

comment:4 Changed on Apr 22, 2011 at 12:28:36 PM by Jennifer Averett

Resolution: fixed
Status: newclosed

Modifications Merged.

comment:5 Changed on Nov 24, 2014 at 6:58:28 PM by Gedare Bloom

Version: HEAD4.11

Replace Version=HEAD with Version=4.11 for the tickets with Milestone >= 4.11

Note: See TracTickets for help on using tickets.